import * as rx from 'rxjs';
import Error from './error';
export { Error } from './error';
import LogMsg from './log-msg';
export { LogMsg } from './log-msg';
export declare enum Match {
    NUMBER = "number",
}
export interface MatcherCallback<T> {
    (obs: Subject<any>, data: T): boolean | Subject<any>;
}
export declare class Matcher<T> {
    readonly type: any;
    readonly cb: MatcherCallback<T>;
    constructor(type: any, cb: MatcherCallback<T>);
}
export declare class Done {
    readonly result: boolean;
    constructor(result: boolean);
}
export declare class Complete {
}
export declare class Subject<T = void> extends rx.Subject<RxMe<T>> {
    readonly objectId: string;
    private readonly obss;
    private readonly matcher;
    private readonly _completed;
    private subscription;
    constructor();
    done(result: boolean): Subject<T>;
    private searchMatcher(matcherIdx, obssIdx, rxme, found);
    passTo<A = T>(obs?: Subject<A> | Subject<A>[]): Subject<T>;
    completed(cb: MatcherCallback<any>): Subject<T>;
    wildCard(cb: MatcherCallback<any>): Subject<T>;
    match<A = T>(typ: any, cb: MatcherCallback<A>): Subject<T>;
    matchError(cb: MatcherCallback<Error>): Subject<T>;
    matchLogMsg(cb: MatcherCallback<LogMsg>): Subject<T>;
    matchDone(cb: MatcherCallback<Done>): Subject<T>;
    matchComplete(cb: MatcherCallback<Complete>): Subject<T>;
}
export interface Observer<T = void> extends rx.Observer<RxMe<T>> {
}
export declare class Observable<T = void> extends rx.Observable<RxMe<T>> {
}
export declare class RxMe<T = void> {
    readonly objectId: string;
    readonly data: any;
    constructor(_data: any);
    passthrough(obs: Observer<RxMe>): boolean;
    forward(obs: Observer<RxMe>): boolean;
    isLogMsg(): boolean;
    asLogMsg(): LogMsg;
    isError(): boolean;
    asError(): Error;
    isKind(a: any): boolean;
    asKind<A = T>(): A;
    asKindAny<A = T>(a: any): any;
}
export declare function data<T>(t: T): RxMe;
export declare function logMsg(level: string, ...parts: any[]): RxMe;
export declare function error(a: any): RxMe;
export declare function done(a: boolean): RxMe;
export declare function complete(): RxMe;
export default RxMe;
